
#define MyDemoBoard
#define Version "26/10/2015"
//Hardware :
// carte Microchip PICkit2 44 pin demo board
// PIC16F887
// 8 leds sur PORTD
// switch sur RB0
// module bluetooth
//     RC6 -->--RXD HC06
//     RC7 --<--TXD HC06

#define POWER_SUPPLY_5V
#define FOSC 8  // MHz
#define BAUD 9600  // UART1    vers module BT HC06
 //ac:proto_freq

  //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define Bell 7
#define Byte unsigned char

#ifdef MyDemoBoard
//  pinout settings
sbit LD7 at RD7_bit;
sbit LD6 at RD6_bit;
sbit LD5 at RD5_bit;
sbit LD4 at RD4_bit;
sbit LD3 at RD3_bit;
sbit LD2 at RD2_bit;
sbit LD1 at RD1_bit;
sbit LD0 at RD0_bit;

sbit SW1 at RB0_bit ;

 //           12345678901234567890
const char chaine0[]="16F877 Card 44 pin: Test Freq measure on RB0 \r\n ";
const char chaine1[]="FOSC interne 8MHZ  Port COM 96000 \r\n";
//const char chaine2[]="PROJET MikroC :16F887_test_Freqmeter_RBO_TMR0.mcppi\r\n";
const char *RS_Str[]={chaine0,chaine1};//,chaine2};

char TEXTE[80];
char CRam1[20];
char *txt;
char *p1;
//char c1;
unsigned int i,j,k;
//unsigned char cpt1, cpt2 ,cpt3 ;
////unsigned long T1;
unsigned long Freq;
#endif

//initialisation et declaration des variables utiliss
int test=1;// variable pour savoir si premier ou second front montant pour mesure de la periode
unsigned int dep=0;
long temps=0;
float periode=0;
float f1;
unsigned int  frequence;

//---------------------------------ROUTINE D INTERRUPTION--------------------------------
//#pragma origin 0x4  // <- ??
void interrupt(void)   // a chaque interruption sur rbo/int calcul debut et fin de periode
{
        // --- RB0 interrupt ---
          if((INTF_bit==1) && (INTE_bit==1))
           {
                 if(test==1)
                 {
                     TMR0=0;
                     test=2;
                     INTF_bit=0;
                 }
                 if(test==2)
                 {
// si temps est un int .. limite  +32767  -32768  .. debordement si dep>127
//avec  un unsigned int .. 0  65535 .. dja mieux
// ou avec un entier long .. tranquille !
                     temps=(long) TMR0+ (long)dep * 256;
                     test=1;
                     INTF_bit=0;
                     T0IF_bit=0;
                     dep=0;
                     
                  }
             }
        // timer0 interrupt
           if(( T0IF_bit==1) && (T0IE_bit==1))
             {
                     dep=dep+1;
                     T0IF_bit=0;
             }
}

 #ifdef MyDemoBoard
 // --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

#endif


//-------------------------------Fonction principale------------------------------
// affichage de la frequence mesur , sur port c et portd
void main()
{
      #ifdef MyDemoBoard
      //Oscillateur_Interne car pas de Quartz !
       OSCCON=0b01110001 ; // 8MHz (111) & SCS=1  (sinon 4 MHz par defaut)
       Delay_ms(1000);
       TRISC=0x80;     // car RC7 =entree UART !
       #else
       TRISC=0x00;
       #endif
       
       TRISD=0;
       TRISB.B0=1; // rbo en entree su microcontrolleur

       ANSEL = 0;
       ANSELH = 0;
       PORTD=0;
       PORTC=0;
       test=1;

       OPTION_REG = 0xC0;  //bit7-> RBPU=1 (off), bit6 -> INTEDG=1 (front montant)
                         //bit5-> T0CS=0 (fosc/4), bit4-> TOSE=0
                         //bit3-> PSA=0 (prescaler timer0), bit<3:0> 000 -> timer0 rate 1:2
                         // => OPTION_REG=0b11000000=0xC0
                         // temps entre deux cycles avec ces parametres =0.4 microsecondes  at 20MHz
  //------------------------------
  #ifdef MyDemoBoard
    Freq = Clock_kHz();
    LongWordToStr(Freq, txt) ;
    if (Freq < 8001) 
    {
      UART1_Init(9600);  // Fosc=8MHz
      }
        else
        {
           UART1_Init(19200);  // Q=20Mhz
    }
    txt=&TEXTE[0];    // init pointeur
    UART1_Write(CLS);  // efface ecran terminal VBRAY
    CRLF();
    Delay_ms(1000);
    UART1_Write_CText("16F877 Card 44 pin: Test Freq measure on RB0 \r\n ");
    UART1_Write_CText("FOSC interne 8MHZ  Port COM 96000 \r\n");
    UART1_Write_CText("Start Version : "Version"\r\n");
  #endif
  // -----------------------
  
    PEIE_bit=1;
    INTE_bit=1;
    INTF_bit=0;
    T0IE_bit=1;
    T0IF_bit=0;
    GIE_bit=1;

       for(;;)
       {
      #ifdef MyDemoBoard
       txt=&TEXTE[0];
       UART1_Write_CText("Mesure de Raw Freq= ");
       periode=(float) temps ;
       f1=1000000.0/periode;
       frequence=(unsigned int)f1; // pour affichage sur leds  en Hz  ex: 249
       WordToStr(frequence,txt);
       UART1_Write_Text(txt);
       UART1_Write(TAB);
        UART1_Write_CText("Periode= ");
        FloatToStr(periode,txt);
       UART1_Write_Text(txt);
       UART1_Write(TAB);
        UART1_Write_CText("Frequence= ");
        FloatToStr(f1,txt);
         UART1_Write_Text(txt);
       CRLF();
       Delay_ms(1000);  // on ralenti tout  pour mieux visualiser surr l'ecran
       // PORTC = frequence >> 8;  // port non disponible !!
       PORTD = frequence & 0x00FF;
       #else
           periode=(float)temps *4.0 ;
           f1=10000000.0/periode;
           frequence=(unsigned int)f1;
           
           PORTD = frequence & 0x00FF;         // On envoie les 8 bits de points faibles sur le port D
           PORTC = frequence >> 8;    //pour faire apparaitre les 8 bits de poids fort restant sur le PORTC
      #endif

    
       }

}

 /*
 resultat terminal VBRAY

20:18:53.265> 16F877 Card 44 pin: Test Freq measure on RB0
20:18:53.328>  FOSC interne 8MHZ  Port COM 96000
20:18:53.328> Start Version : 26/10/2015
20:18:53.390> Mesure de Raw Freq= 65535	Periode= 0	Frequence= 6.805639e38
20:18:54.640> Mesure de Raw Freq=     4	Periode= 205316.9	Frequence= 4.870517
20:18:55.828> Mesure de Raw Freq=     4	Periode= 205316.9	Frequence= 4.870517
20:18:57.015> Mesure de Raw Freq=     4	Periode= 205316.9	Frequence= 4.870517
20:18:58.265> Mesure de Raw Freq=     4	Periode= 205316.9	Frequence= 4.870517
20:18:59.453> Mesure de Raw Freq=     4	Periode= 205316.9	Frequence= 4.870517
20:19:00.640> Mesure de Raw Freq=     9	Periode= 102660.9	Frequence= 9.740797
20:19:01.828> Mesure de Raw Freq=     9	Periode= 102660.9	Frequence= 9.740797
20:19:03.078> Mesure de Raw Freq=     9	Periode= 102660.9	Frequence= 9.740797
20:19:04.265> Mesure de Raw Freq=    19	Periode= 51204.99	Frequence= 19.52934
20:19:05.453> Mesure de Raw Freq=    19	Periode= 51204.99	Frequence= 19.52934
20:19:06.703> Mesure de Raw Freq=    19	Periode= 51204.99	Frequence= 19.52934
20:19:07.890> Mesure de Raw Freq=    10	Periode= 99332.99	Frequence= 10.06714
20:19:09.078> Mesure de Raw Freq=    39	Periode= 25604.99	Frequence= 39.05487
20:19:10.328> Mesure de Raw Freq=    39	Periode= 25604.99	Frequence= 39.05487
20:19:11.515> Mesure de Raw Freq=    39	Periode= 25604.99	Frequence= 39.05487
20:19:12.703> Mesure de Raw Freq=    39	Periode= 25604.99	Frequence= 39.05487
20:19:13.953> Mesure de Raw Freq=    78	Periode= 12804.99	Frequence= 78.09448
20:19:15.140> Mesure de Raw Freq=    78	Periode= 12804.99	Frequence= 78.09448
20:19:16.328> Mesure de Raw Freq=    78	Periode= 12804.99	Frequence= 78.09448
20:19:17.578> Mesure de Raw Freq=   162	Periode= 6148.999	Frequence= 162.628
20:19:18.765> Mesure de Raw Freq=   162	Periode= 6148.999	Frequence= 162.628
20:19:20.015> Mesure de Raw Freq=   162	Periode= 6148.999	Frequence= 162.628
20:19:21.203> Mesure de Raw Freq=   162	Periode= 6148.999	Frequence= 162.628
20:19:22.390> Mesure de Raw Freq=   324	Periode= 3076.999	Frequence= 324.9918
20:19:23.640> Mesure de Raw Freq=   324	Periode= 3076.999	Frequence= 324.9918
20:19:24.890> Mesure de Raw Freq=   324	Periode= 3076.999	Frequence= 324.9918
20:19:26.078> Mesure de Raw Freq=   324	Periode= 3076.999	Frequence= 324.9918
20:19:27.328> Mesure de Raw Freq=   648	Periode= 1540.999	Frequence= 648.9292
20:19:28.578> Mesure de Raw Freq=   648	Periode= 1540.999	Frequence= 648.9292
20:19:29.828> Mesure de Raw Freq=   648	Periode= 1540.999	Frequence= 648.9292
20:19:31.078> Mesure de Raw Freq=   648	Periode= 1540.999	Frequence= 648.9292
20:19:32.328> Mesure de Raw Freq=    39	Periode= 25604.99	Frequence= 39.05487
20:19:33.515> Mesure de Raw Freq=     9	Periode= 102660.9	Frequence= 9.740797
20:19:34.703> Mesure de Raw Freq=     9	Periode= 102660.9	Frequence= 9.740797
20:19:35.953> Mesure de Raw Freq=     9	Periode= 102660.9	Frequence= 9.740797
20:19:37.140> Mesure de Raw Freq=     9	Periode= 102660.9	Frequence= 9.740797
20:19:38.328> Mesure de Raw Freq=    97	Periode= 10244.99	Frequence= 97.60858
20:19:39.578> Mesure de Raw Freq=    97	Periode= 10244.99	Frequence= 97.60858
20:19:40.765> Mesure de Raw Freq=   205	Periode= 4868.999	Frequence= 205.3809
20:19:41.953> Mesure de Raw Freq=   205	Periode= 4868.999	Frequence= 205.3809
20:19:43.203> Mesure de Raw Freq=   205	Periode= 4868.999	Frequence= 205.3809
20:19:44.390> Mesure de Raw Freq=   433	Periode= 2308.999	Frequence= 433.0878
20:19:45.640> Mesure de Raw Freq=   433	Periode= 2308.999	Frequence= 433.0878
20:19:46.828> Mesure de Raw Freq=   433	Periode= 2308.999	Frequence= 433.0878
20:19:48.078> Mesure de Raw Freq=   433	Periode= 2308.999	Frequence= 433.0878
20:19:49.328> Mesure de Raw Freq=   971	Periode= 1028.999	Frequence= 971.8172
20:19:50.515> Mesure de Raw Freq=   971	Periode= 1028.999	Frequence= 971.8172
20:19:51.765> Mesure de Raw Freq=   971	Periode= 1028.999	Frequence= 971.8172
20:19:53.015> Mesure de Raw Freq=   971	Periode= 1028.999	Frequence= 971.8172
20:19:54.328> Mesure de Raw Freq=  1934	Periode= 517	Frequence= 1934.235
20:19:55.578> Mesure de Raw Freq=  1934	Periode= 517	Frequence= 1934.235
20:19:56.890> Mesure de Raw Freq=  1934	Periode= 517	Frequence= 1934.235
20:19:58.203> Mesure de Raw Freq=  1934	Periode= 517	Frequence= 1934.235

*/

