#define Version "03-04-2015"

// Interruption RB0 via switch 1
//  chaque IT on allume la led7  et alternativement la led 3 ou Led4
// l'IT timer0  32mS  comptabilise apres 62 Interrupts: 2 secondes
// et eteint la led 7  , et increment un compteur cpt3
//
// la boucle de fond clignote alternativement la led 0 et la led1/  chaque seconde
// la valeur du cpt d'IT Rb0 et la valeur du compteur de tour complet (62x Timer0)
// est envoyee sur l'UART -> HC06 (jaune 6 pins) -> bluetooth .. Bluesoleil -> teraterm 9600,n,8,1
// apres 32 IT , relance de la boucle principale



//Hardware :
// carte Microchip PICkit2 44 pin demo board
 //ac:board_schem
// PIC16F887
// 8 leds sur PORTD
// switch sur RB0
// module bluetooth 
//     RC6 -->--RXD HC06
//     RC7 --<--TXD HC06
// CONFIG1 : $2007 : 0x2CF4
// CONFIG2 : $2008 : 0x0700

#define POWER_SUPPLY_5V
#define FOSC 8  // MHz
#define BAUD 9600  // UART1    vers module BT HC06


  //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define Bell 7
#define Byte unsigned char



//  pinout settings
sbit LD7 at RD7_bit;
sbit LD6 at RD6_bit;
sbit LD5 at RD5_bit;
sbit LD4 at RD4_bit;
sbit LD3 at RD3_bit;
sbit LD2 at RD2_bit;
sbit LD1 at RD1_bit;
sbit LD0 at RD0_bit;

sbit SW1 at RB0_bit ;


 //           12345678901234567890
const char chaine0[]="16F877 Card 44 pin: Test IT Timer0 RB0 \r\n ";
const char chaine1[]="FOSC interne 8MHZ  Port COM 96000 \r\n";
const char chaine2[]="PROJET MikroC :16F887_test_IT_RB0_TMR0.mcppi\r\n";

const char *RS_Str[]={chaine0,chaine1,chaine2};

char TEXTE[40];
char CRam1[20];
char *txt;
char *p1;
char c1;
unsigned int i;
unsigned int j,k;
unsigned char cpt1, cpt2 ,cpt3 ;
unsigned long T1;



void Interrupt() iv 0x0004 ics ICS_AUTO 
{
// ===== Interrupt RB0  ===========
 if ((INTCON.INTE)&& (INTCON.INTF))
 {
   LD3=1;
   LD4=0;
   LD7=1;
   // reinit timer0 , pour eteindre led apres tempo 2sec
   cpt1=62;  // 2sec
   TMR0=0;
   INTCON.T0IF=0; // Raz Flag
   if ((cpt2 & 0x02)==2)
   {
      LD3=0;      // RAZ  led3  every 2 IT
      LD4=1;
   }
   cpt2++  ;
   INTCON.INTF=0;  // raz flag
 } /// rb0
// ====  IT Timer0  =============
  if((INTCON.TMR0IE) && (INTCON.T0IF))
  { 
     cpt1--;
    if(cpt1==0)
     {
        cpt3++;
        LD7=0;
        cpt1=62;  // 2sec
      }
     TMR0=0;
     INTCON.T0IF=0; // Raz Flag
  }

}

 // --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}


void main()
 {

  OSCCON=0b01110001 ; // 8MHz (111) & SCS=1  (sinon 4 MHz par defaut)

  ANSEL  = 0;                        // Configure AN pins as digital I/O
  ANSELH = 0;
  C1ON_bit = 0;                      // Disable comparators
  C2ON_bit = 0;
  TRISB=0xFF;
  TRISC=0xFF;
  TRISA=0xFF;
  TRISD=0;
  PORTD=0;
  
 // Init_Hardware();
 // Delay_ms(1000);
   txt=&TEXTE[0];    // init pointeur

  TRISB.TRISB0 = 1;  // RB0 input

  
  UART1_Init(9600);               // Initialize UART module at 9600 bps
  Delay_ms(1000);                  // Wait for UART module to stabilize
   UART1_Write_CText(Version);
  CRLF();

    UART1_Write_CText("Start");
    UART1_Write(10);
    UART1_Write(13);
   txt=&TEXTE[0];
  
  /*
  
  txt=strcpy(txt,"0000=0000000=0000000=0000000=4500000=4700000=65000 00=4800000");
 // p1= strcpy(txt,"&GPGLL,3723.2475,N,12158.3416,W,161229.487,A*2C");
   UART1_Write_text(txt);
  UART1_Write(13);
  Delay_ms(1000);
  i=strlen(txt);
  p1=txt;
//  p1=strtok(txt,",");
    p1=strtok(p1,"=");
    UART1_Write_text(p1);
  UART1_Write(13);
  Delay_ms(1000);
  i=0;
   do
  {
//    p1=strtok(0, ",");
     p1=strtok(0, "=");
    if (p1!=0)    UART1_Write_text(p1);
     UART1_Write(13);
    Delay_ms(1000);
  }while (p1!=0) ;
  Delay_ms(1000);
  p1= strcpy(txt,"\n End of programe\n");
  UART1_Write_text(txt);
  Delay_ms(5000);
  } while(1);
 }
*/

// init interrupt RB0
// timer0
// 0x81 OPTION_REG   RBPU  INTEDG  T0CS  T0SE  PSA   PS2  PS1   PS0
        OPTION_REG= 0b00000111;
        OPTION_REG.T0CS=0;      // internal Fosc/4
        OPTION_REG.INTEDG=0;   //  IT on falling edge
        OPTION_REG.PSA=0;      //  prescaler on Timer0
        OPTION_REG.PS2=1;       //  divi by 128
        OPTION_REG.PS1=1;        // timer0 IT every 32mS
        OPTION_REG.PS0=1;
        INTCON.T0IF=0;

while(1)
{

   UART1_Write_CText(RS_Str[0]);
   UART1_Write_CText(RS_Str[1]);
   UART1_Write_CText(RS_Str[2]);

    cpt2=0;
    cpt1=62; // 2 sec
    TMR0=0;
    INTCON.INTE=1;  // enable RB0 IT interrupt
    INTCON.TMR0IE=1;   // disable timer0 It
    INTCON.GIE=1;

  while(cpt2<32)
  {
   LD0=1;
   LD1=0;
    ByteToStr(cpt3,txt);
    UART1_Write_Text(txt);
    UART1_Write(TAB);
    
   Delay_ms(1000);
   LD0=0;
   LD1=1;
   // UART1_Write('\\');
   Delay_ms(1000);
    if (UART1_Data_Ready()==1)
     {     // If data is received,
      c1 = UART1_Read();     // read the received data,
      UART1_Write(c1);       // and send data via UART
    }
    ByteToStr(cpt2,txt);
    UART1_Write_Text(txt);
     CRLF();
  }
    CRLF();
    UART1_Write_CText("Relance apres 32 it RB0");
    CRLF();
 }
 }



/*
 15      31
 16      31
 17      32

Relance apres 32 it RB0
16F877 Card 44 pin: Test IT Timer0 RB0
 FOSC interne 8MHZ  Port COM 96000
PROJET MikroC :16F887_test_IT_RB0_TMR0.mcppi
Start
 17       0
 17       0
 18       0
 19       0
 20       0
 21       0
 */